import * as mysql from 'mysql';
import * as dbSettings from '../../dbSettings';

const connection = mysql.createConnection(dbSettings);

export function init() {
  return new Promise((resolve, reject) => {
    connection.connect(function(err) {
      if (err) {
        reject(err);
      }
      resolve();
    });
  });
}

export function query(command: string): Promise<{ results: any, fields?: mysql.FieldInfo[] }> {
  return new Promise((resolve, reject) => {
    connection.query(command, function(error, results, fields) {
      if (error !== null) {
        reject(error);
      }
      resolve({ results, fields });
    });
  });
}

export function exit(): void {
  connection.end();
}
